#!/usr/bin/env python

# This script will replace the versioneer source version file configured in
# `setup.cfg` with a file containing the hardcoded version generated by
# versioneer. It is meant to be used before building the debian package, so the
# generated package reports the correct version, as would be generated by
# versioneer if this was a python package.

import ConfigParser
import versioneer

# get the path to the version file
config = ConfigParser.RawConfigParser()
config.read('setup.cfg')
source_file = config.get('versioneer', 'versionfile_source')

# replace version file in source tree
versions = versioneer.get_versions()
versioneer.write_to_version_file(source_file, versions)
